package dev.pfaff.recipe_nope.mixin;

import dev.pfaff.recipe_nope.injector.UnconstrainedRedirect;
import net.minecraft.client.network.ClientPlayNetworkHandler;
import net.minecraft.client.recipebook.ClientRecipeBook;
import net.minecraft.recipe.Recipe;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Redirect;

@Mixin(ClientPlayNetworkHandler.class)
public abstract class ClientPlayNetworkHandlerMixin {
	@UnconstrainedRedirect(method = "onGameJoin", at = @At(value = "NEW", target = "()Lnet/minecraft/client/recipebook/ClientRecipeBook;"))
	private ClientRecipeBook onGameJoin$noRecipeBook() {
		return null;
	}

	@Redirect(method = "onSynchronizeRecipes", at = @At(value = "INVOKE", target = "Lnet/minecraft/client/recipebook/ClientRecipeBook;reload(Ljava/lang/Iterable;)V"))
	private void onSynchronizeRecipes$noRecipeBook(ClientRecipeBook instance, Iterable<Recipe<?>> recipes) {
	}
}
